# MPI Environment on the RWTH Cluster CLAIX

## Before You Start

Before you start, log into one of our Linux cluster frontends:

- **login18-1.hpc.itc.rwth-aachen.de**
- **login18-2.hpc.itc.rwth-aachen.de**

using `ssh` or a corresponding client.

Then, download the MPI lab archive from the [PPCES 2022 website](https://blog.rwth-aachen.de/itc-events/event/ppces-2022/) (the link is also published in the Slack Channel) and extract it to a suitable location (e.g., in a directory named `PPCES2022/MPI`) using the following commands :

### C/C++

```shell
% mkdir -p ~/PPCES2022/MPI
% cd ~/PPCES2022/MPI
% wget https://tinyurl.com/ppces2022-MPI-labs-C
% tar -xvf ppces2022-MPI-labs-C
```

### Fortran

```shell
% mkdir -p ~/PPCES2022/MPI
% cd ~/PPCES2022/MPI
% wget https://tinyurl.com/ppces2022-MPI-labs-Fortran
% tar -xvf ppces2022-MPI-labs-Fortran
```

The lab archive contains skeleton code for the exercises described below. Intermediate solutions are provided where appropriate. Sample solutions to all problems are also provided in the **solutions** folder. We would advise you to not look at the solutions before you have tried your best to solve each exercise on your own.

## Building the example code

The CLAIX shell environment uses the `module` system to provide different
versions of specific software. By default the *Intel MPI* and *Intel compiler*
modules are loaded. It is easiest to copy the `make.def.intel` for Intel
compiler & MPI to `make.def` in the respective `common/` directory of your
exercises.

Each problem comes with a Makefile with the following targets:
##### `default` target

This target build the respective exercise executable.

```sh
% make
```

##### `clean` target

This target removes all build files, including the executable itself.

```sh
% make clean
```
##### `run` target

This target uses `mpiexec` to start a small MPI job with 4 processes of the
given executable.

```sh
% make run
```



